;;;;;;;;;;;;;;;;;;;
;Koopa Engine
;By Maxx
; This makes Mario a koopa in whatever level you place it in. To be more specific, mario will look exactly like a koopa (assuming you used vanilla graphics; and as long as the koopa stayed the same tile, that doesn't really matter either.
;There are some limitations:
; 1. Mario has to be "big" throughout the level (causes glitches if he's any other power)
; 2. Mario has to be killed in one hit (don't worry, I've handled that)
; 3. Mario cannot duck 
; 4. Mario cannot carry things
; 5. Mario cannot run at full speed.
; This is mostly due to the fact that otherwise, it would require patches that heavily modify what frame to show mario in. It also gives the koopa a slightly realistic limitation, I suppose.
;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL		; no init

	                dcb "MAIN"
JSR Main
RTL
;;;;;;;;;;;;;
deathJSL:
STZ $19    ;\
JSL $00F606;/ make mario small and kill him
RTS    


Main:
LDA #$00  ;\
STA $AA,x ;|
STA $B6,x ;/ no icky sprite moving stuff
;(I don't know if STZ $xx,x exists so I just took the default)

LDA $71     ;\ if mario is hurt, kill him actually
CMP #$01    ;|
BEQ deathJSL;/

LDA $13E4       ;\ 
CMP #$6E        ;| this limits how fast mario can go to make sure that those little extra bits of mario don't pop up when he is running at max speed
BCS limitspeed  ;|
BRA nolimitspeed;/

limitspeed:
LDA #$6E
STA $13E4
nolimitspeed:

LDA $7B
CMP #$2A
BCS Poscheck
afterpos:
LDA #$2A
EOR #$FF
INC A
STA $01
LDA $7B
CMP $01
BCC Negcheck
BRA nolimit7B
Poscheck:
LDA $7B
BPL limit7B
BRA afterpos
Negcheck:
LDA $7B
BMI neglimit7B
BRA nolimit7B

limit7B:
LDA #$29
STA $7B
BRA nolimit7B

neglimit7B:
LDA #$2A
EOR #$FF
DEC A
STA $7B

nolimit7B:

LDA #$01    ;\
STA $1470   ;/ this makes mario always "hold an enemy," but in fact the only thing it really does here is make him not be able to pick up anything.
STA $148F

LDA #$01    ;\
STA $19     ;/ but he's always big

STZ $73     ; No ducking, it causes glitches :(

LDA $0313   ;\
ORA #$08    ;| Setting the palette for the top tile
STA $0313   ;/

LDA $0317   ;\
ORA #$08    ;| setting the palette for the lower tile
STA $0317   ;/

LDA #$82    ;\ setting the tile for the head
STA $0312   ;/

LDA $7B     ;\
CMP #$10    ;|
BCC nospec  ;| if mario is moving slow enough, don't do the walking frame
LDA $7B     ;|
CMP #$F0    ;|
BCS nospec  ;/

LDA $13     ;\
AND #$02    ;|
BNE specialsettile ;/ but otherwise set it every few frames

nospec:
LDA $7B  ;\\ 0316 = Lower Tile #
AND #$04 ;||
LSR      ;|| make mario's speed have some say in the speed of the run
CLC      ;|/
STA $00  ;|setting tile (sometimes walking)
LDA #$A0 ;|
ORA $00  ;|
STA $0316;/
RTS

specialsettile:
LDA #$A2    ;\
STA $0316   ;/ setting the tile as walking
RTS			

